#property copyright "Copyright  2007, oilfxpro@raj-enterprises.co.uk, Programming Copyright  2007, OILFXPRO.com"
#property link "oildaytrader.com, Free licencse to http://www.fxfisherman.com"




extern int take_profit = 20;
extern int stop_loss = 20;
extern int last_bar= 1;
extern int trading_opening_time = 0;
extern int trading_close_time = 0;
extern bool time_range = false;
extern int trailing_stop = 60;
extern double lot = 0.1;
extern double risk = 0.02;
extern bool mm = false;
extern bool long = true;
extern bool short = true;

int get_take_profit(int order_type)
{
   if (trailing_stop > 0) {
      return(0);
   } else if (order_type == OP_BUY) {
      return(Bid + take_profit * Point);
   } else if (order_type == OP_SELL) {
      return(Ask - take_profit * Point);  
   } else {
      return(0);
   }
}

double get_new_lot()
{
   double new_lot;
   
   if (mm == true) {
      new_lot = (AccountFreeMargin() * risk) / stop_loss / 10;
   } else {
      new_lot = lot;
   }
   
   if (new_lot < 0.1) {
      new_lot = 0.1;
   }
   
   new_lot = NormalizeDouble(new_lot, 1);
   
   return(new_lot);
}

int start()
{
   double hma4_1, hma4_2;
   double hma6_1, hma6_2;
   double hma8_1, hma8_2;
   double hma10_1, hma10_2;
   double hma20_1, hma20_2;
   double hma40_1, hma40_2;
   double hma80_1, hma80_2;
   double hma200_1, hma200_2;
   double hma420_1, hma420_2;
   
   if (last_bar < 0) {
      last_bar = 1;
   }
   
   if (OrdersTotal() == 0 && ((TimeHour(Time[0]) >= trading_opening_time && TimeHour(Time[0]) < trading_close_time) || !time_range)) {
      hma4_1 = iCustom(Symbol(), 0, "HMA_v07.1", 4, 200, 1, last_bar);
      hma4_2 = iCustom(Symbol(), 0, "HMA_v07.1", 4, 200, 1, last_bar + 1);
      hma6_1 = iCustom(Symbol(), 0, "HMA_v07.1", 6, 200, 1, last_bar);
      hma6_2 = iCustom(Symbol(), 0, "HMA_v07.1", 6, 200, 1, last_bar + 1);
      hma8_1 = iCustom(Symbol(), 0, "HMA_v07.1", 8, 200, 1, last_bar);
      hma8_2 = iCustom(Symbol(), 0, "HMA_v07.1", 8, 200, 1, last_bar + 1);
      hma10_1 = iCustom(Symbol(), 0, "HMA_v07.1", 10, 500, 1, last_bar);
      hma10_2 = iCustom(Symbol(), 0, "HMA_v07.1", 10, 500, 1, last_bar + 1);
      hma20_1 = iCustom(Symbol(), 0, "HMA_v07.1", 20, 500, 1, last_bar);
      hma20_2 = iCustom(Symbol(), 0, "HMA_v07.1", 20, 500, 1, last_bar + 1);
      hma40_1 = iCustom(Symbol(), 0, "HMA_v07.1", 40, 800, 1, last_bar);
      hma40_2 = iCustom(Symbol(), 0, "HMA_v07.1", 40, 800, 1, last_bar + 1);
      hma80_1 = iCustom(Symbol(), 0, "HMA_v07.1", 80, 800, 1, last_bar);
      hma80_2 = iCustom(Symbol(), 0, "HMA_v07.1", 80, 800, 1, last_bar + 1);
      hma200_1 = iCustom(Symbol(), 0, "HMA_v07.1", 200, 1000, 1, last_bar);
      hma200_2 = iCustom(Symbol(), 0, "HMA_v07.1", 200, 1000, 1, last_bar + 1);
      hma420_1 = iCustom(Symbol(), 0, "HMA_v07.1", 420, 2000, 1, last_bar);
      hma420_2 = iCustom(Symbol(), 0, "HMA_v07.1", 420, 2000, 1, last_bar + 1);
      
      if (
         hma4_1 > hma4_2 &&
         hma6_1 > hma6_2 &&
         hma8_1 > hma8_2 &&
         hma10_1 > hma10_2 &&
         hma20_1 > hma20_2 &&
         hma40_1 > hma40_2 &&
         hma80_1 > hma80_2 &&
         hma200_1 > hma200_2 &&
         hma420_1 > hma420_2 &&
         long
         )
      {
         OrderSend(Symbol(), OP_BUY, get_new_lot(), Ask, 3, Ask - stop_loss * Point, get_take_profit(OP_BUY), "", 0, 0, Green);
      }
         
      if (
         hma4_1 < hma4_2 &&
         hma6_1 < hma6_2 &&
         hma8_1 < hma8_2 &&
         hma10_1 < hma10_2 &&
         hma20_1 < hma20_2 &&
         hma40_1 < hma40_2 &&
         hma80_1 < hma80_2 &&
         hma200_1 < hma200_2 &&
         hma420_1 < hma420_2 &&
         short
         )
      {
         OrderSend(Symbol(), OP_SELL, get_new_lot(), Bid, 3, Bid + stop_loss * Point, get_take_profit(OP_SELL), "", 0, 0, Red);
      }
   } else {
      OrderSelect(0, SELECT_BY_POS, MODE_TRADES);
      
      switch (OrderType()) {
         case OP_BUY:
            if (TimeHour(Time[0]) >= trading_close_time && time_range) {
               OrderClose(OrderTicket(), OrderLots(), Bid, 3, Violet);
            }
            
            if (trailing_stop != 0 && Bid - OrderOpenPrice() >= trailing_stop * Point && OrderOpenPrice() > OrderStopLoss()) {
               OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), 0, 0, Aqua);
            }
            
            if (trailing_stop != 0 && Bid - OrderStopLoss() >= 2 * trailing_stop * Point && OrderOpenPrice() <= OrderStopLoss()) {
               OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss() + trailing_stop * Point, 0, 0, Aqua);
            }
            break;
         
         case OP_SELL:
            if (TimeHour(Time[0]) >= trading_close_time && time_range) {
               OrderClose(OrderTicket(), OrderLots(), Ask, 3, Violet);
            }
            
            if (trailing_stop != 0 && OrderOpenPrice() - Ask >= trailing_stop * Point && OrderOpenPrice() < OrderStopLoss()) {
               OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), 0, 0, Aqua);
            }
            
            if (trailing_stop != 0 && OrderStopLoss() - Ask >= 2 * trailing_stop * Point && OrderOpenPrice() >= OrderStopLoss()) {
               OrderModify(OrderTicket(), OrderOpenPrice(), OrderStopLoss() - trailing_stop * Point, 0, 0, Aqua);
            }
      }
   }
   
   return(0);
}

